' **********************************************************************
' ** Program:         ADLPLAY.BAS                                     **
' ** Type   :         Main Program                                    **
' ** Author :         Joseph Scally                                   **
' ** Date   :         Nov 89                                          **
' ** Purpose:         Play ADLIB MUSIC CARD .ROL FILES AND DISPLAY    **
' **                  STATISTICS.                                     **
' **********************************************************************

REM $INCLUDE: 'Mstruct.h'
REM $INCLUDE: 'Sound.h'
REM $INCLUDE: 'BankDef.h'


 DEFINT A-Z
 DIM SHARED IndexInfo(200) AS nameHeader
 DIM SHARED INSTRUM(MAXPARAMETERS)          'Holds Instrument Parameters
 DIM SHARED DirEntry$(255, 4)               'Directory Info For Display
 DIM SHARED Items$(55)                      'Retains Instruments used for
                                            'Display Purposes
 DIM SHARED Pnames$(14)                     'Dim of Paramater names
 


 BankName$ = "Standard"
 LoadBank (BankName$)
 FOR Rp = 1 TO 14                           'Load The various parameter names
     READ Pnames$(Rp)                       'into an array to make later
 NEXT                                       'display possible.
 OpenScreen
Top:
 Iptr% = 0                                  'Initialize Variables and clear
 IECount% = 0
 Path$ = "c:\music\songs\"
 ROLPath$ = "c:\music\songs\"
 Messout "Select Song To Play And Hit Enter"
 FOR CArray = 0 TO 54
 Items$(CArray) = ""
 NEXT
 ShowDir 5, 1, 11, 11, 0, 1, 0, 17, DirEntry$(), Reply%, "N"
 Initialize                                 'Set up Sound Card
 SetMode PERCUSSIVE                         'Could also be MELODIC
 ROLFile = FREEFILE
 OPEN ROLPath$ + DirEntry$(Reply%, 0) FOR BINARY AS ROLFile
 GET ROLFile, 1, Mh                         'Read Music Header
 Tempo Mh.Tempo                             'Set Initial Tempo
 SetTempoEvents (ROLFile)                   'Set Future Temo Events.

'***************************************************************************
'**                         Main Loop Begins Here                         **
'***************************************************************************
 FOR voice% = 0 TO MAXVOICES                'This portion cycles through the
     GET ROLFile, , VoiceHeader             '11 voices and loads the notes.
     SetVoice voice%                        'There is extensive use of user
     VHD = VoiceHeader.Vduration            'defined variables as listed in
     DO WHILE VHD > NULL                    'the Mstruct.H and BankDef.H files.
         GET ROLFile, , Pnote
         DDuration = Pnote.duration
         LDuration = Pnote.duration
         IF Pnote.note = NULL THEN
            DDuration = NULL
         END IF
         Pnote.note = Pnote.note - NOTEOFFSET
         PlayNote Pnote.note, DDuration, Mh.TicksPerBeat, LDuration, Mh.TicksPerBeat
         VHD = VHD - Pnote.duration
     LOOP
 SetInstrumentEvents ROLFile, voice%
'========================================================================
SetVolumeEvents (ROLFile)
SetPitchEvents (ROLFile)
 NEXT voice%                'Increment the voice and do it all again
 CLOSE ROLFile
 COLOR 11, 0
'============================================================================
 ShowStats                  'Put the song stats on the screen.
 Messout "->> Scroll To See Instrument Paramaters - Space Bar To Start Song <<-"
 ShowIns (IECount% - 1)
 StartSong
 Messout "->> Hit Any Key To interrupt <<- "
 DO WHILE CheckCardStatus AND INKEY$ = ""
 LOOP
 Initialize
 Messout "->> Hit Any Key To Continue ***** Esc To Exit <<- "
 w$ = INPUT$(1)
 IF w$ = CHR$(27) THEN END
 RestoreScreen
 ClrArea 6, 50, 22, 77, 11         'Routine to clear old info off the screen
 ClrArea 8, 40, 14, 44, 11         'to prepare for new stats
 GOTO Top

ErrorHandle:
'This is a general purpose Error handling routine.
             SELECT CASE ERR
                    CASE 1
                       SaveScreen
                       MakBox 10, 22, 0, 5, 35, 4, 0
                       LOCATE 11, 28
                       PRINT "Instrument "; UCASE$(StripCString(InstrumentEvent.InstrumentName)); " Not Found"
                       LOCATE , 28
                       PRINT "In BankFile "; UCASE$(BankName$) + ".BNK"
                       LOCATE , 28
                       PRINT "PIANO1 BEING SUBSTITUTED"
                       LOCATE , 28
                       PRINT "Hit Any Key To Continue"
                       w$ = INPUT$(1)
                       RestoreScreen
                       RESUME NEXT
                     CASE ELSE
                     GOTO Top
                      

              END SELECT
RETURN

DATA "KSL","FREQ MULT","FEEDBACK","ATTACK","SUSTAIN","SLEVEL","DECAY"
DATA "RELEASE","VOLUME","AM","VIB","KSR","FM","WAVE"

SUB BinSearch (InsName$, Eno%)
 ON ERROR GOTO ErrorHandle
Redo:
 TopList = 1
 BottomList = Bh.UsedEntries
 InsName$ = UCASE$(StripCString(InsName$))
 DO UNTIL (BottomList < TopList)
    Rnum = (TopList + BottomList) / 2
    SearchRecord$ = UCASE$(LEFT$(IndexInfo(Rnum).InstName, LEN(InsName$)))
    SELECT CASE SearchRecord$
        CASE IS = InsName$
             EXIT DO
        CASE IS > InsName$
             BottomList = Rnum - 1
        CASE IS < InsName$
             TopList = Rnum + 1
        CASE ELSE
             EXIT DO
    END SELECT
 LOOP
 Eno% = Rnum
 IF SearchRecord$ <> InsName$ THEN
    InsName$ = "PIANO1"
    ERROR 1
    GOTO Redo
 END IF
END SUB

DEFSNG A-Z
FUNCTION CheckCardStatus% STATIC
'***********************************************************************
'**********Low Level Call to Sound Driver. Returns = 0 *****************
'**********When the song is over.***************************************
'***********************************************************************
 ON ERROR GOTO ErrorHandle             'Go to error handler.
     InRegs.si = FSDGETSTATE           'Call Function fSDGetState = 4
                                       'Function number in SI
     interrupt &H65, InRegs, OutRegs   'Int 65H = Sound Driver.
     CheckCardStatus% = OutRegs.ax
END FUNCTION

DEFINT A-Z
'*******************************************************************
'******* { Generic clear an area routine. Using interrupt }*********
'*******************************************************************
SUB ClrArea (Urow%, Ucol%, Brow%, Bcol%, Attr%)
 InRegs.ax = &H600
 InRegs.cx = (Urow% - 1) * 256 + Ucol% - 1
 InRegs.dx = (Brow% - 1) * 256 + Bcol% - 1
 InRegs.bx = (Attr% * 256&) AND &HFF00
 interrupt &H10, InRegs, OutRegs
END SUB

DEFSNG A-Z
SUB Initialize
' ******************************************************************
' ** This Routine Performs 3 functions. It Call function 0 to     **
' ** Initialize The Driver, Starts The Relative Time Clock and    **
' ** Sets the mode to Percussive which is used most of the time   **
' ** Throughout these routines you will see "NULL" I defined this **
' ** to show where the value sent to the interface is meaningless **
' ******************************************************************

 Soundcard FSDINIT, NULL, NULL, NULL, NULL, NULL
 StartTime
 SetMode PERCUSSIVE
END SUB

DEFINT A-Z
'****************************************************************************
'* This routine which is expecting a pointer into the instuments parameters *
'* array INSTRUM simply formats that information into the display you see   *
'* on the screen. Pprint and Vprint are simple routines in the library that *
'* accept row & col info to make locate statements uneccessary. Pprint for  *
'* strings and Vprint for numerics.                                         *
'****************************************************************************
'
SUB InstruStats (PPOINTER%)               'Global index into INSTRUM
 MakBox 5, 1, 11, 0, 46, 17, 0             'Library routine
 Row% = 5                                  'Initial
 Col% = 6                                  'Values
 Pprint Row%, Col - 2, "[Paramater]"       'Column Titles
 Pprint Row%, Col + 14, "[Modulator]"      ' "
 Pprint Row%, Col% + 32, "[Carrier]"       ' "
 FOR SHP = 1 TO 14
    Pprint Row% + SHP, Col%, Pnames$(SHP)
    Vprint Row% + SHP, Col% + 17, INSTRUM(PPOINTER + SHP)
    Vprint Row% + SHP, Col% + 34, INSTRUM(PPOINTER + (SHP + 13))
 NEXT
END SUB

SUB LoadBank (BankName$)
'***************************************************************************
'* This loads GLOBAL array IndexInfo, which is declared as TYPE nameHeader *
'* (structure defined in Bankdef.h) with the name and data offset of the   *
'* instruments in the Bankfile                                             *
'***************************************************************************
 BankFile = FREEFILE
 OPEN "c:\music\" + BankName$ + ".bnk" FOR BINARY AS BankFile
 GET BankFile, , Bh                         ' Get Bankfile header info
 SEEK BankFile, (Bh.NameOff + 1)            ' Go to first instrument entry
 FOR LoadIndex = 1 TO Bh.TotalEntries       ' Begin loading the index.
     GET BankFile, , IndexInfo(LoadIndex)   '
 NEXT LoadIndex                             '
 CLOSE BankFile                             ' Wrap up and return
END SUB

SUB Messout (Message$)
'*************************************************************************
'** All purpose routine to dump a message to the last row on the screen **
'** NOTE can't use my Pprint routine because the < CR > has to be       **
'** supressed in row 25 to prevent the screen from .jumping.            **
'*************************************************************************
 LOCATE 25, 1                       '
 PRINT SPACE$(80);                  ' Clear Any Previous Message
 MessageLength = LEN(Message$)      ' Get the message length
 Col% = (80 - MessageLength) / 2    ' Get proper column to Center the Message
 LOCATE 25, Col%                    ' Message to print on the last screen
 PRINT Message$;                    ' Row.
END SUB

'Set up the opening screen
SUB OpenScreen STATIC
 CLS
 Path$ = "c:\music\songs\*.rol"
 GetDirData Path$, DirEntry$(), 64, EntryCount%
 COLOR 0, 1
 LOCATE 1, 1
 PRINT STRING$(80, CHR$(220));
 COLOR 11, 0
 Pprint 2, 1, "      AdLib Player / Analyzer     Ver 1.0          J. Scally        June 89     "
 COLOR 0, 1
 PRINT STRING$(80, CHR$(223));
 MakBox 5, 49, 11, 0, 30, 17, 0    ' ***** Library Routine
 MakBox 5, 21, 11, 0, 26, 17, 0
 Pprint 5, 51, "[Voice#]-[Instrum]-[Tick]"
 Pprint 5, 29, "[Statistics]"
 Pprint 6, 24, "Bank Used"
 Pprint 7, 24, "Mode"
 Pprint 8, 24, "Basic Tempo"
 Pprint 9, 24, "Tempo Events "
 Pprint 10, 24, "Pitch Events"
 Pprint 11, 24, "Volume Events"
 Pprint 12, 24, "Instrum Events "
 Pprint 13, 24, "Ticks per Beat"



END SUB

DEFSNG A-Z
SUB PlayNote (note%, duration%, Dlay%, AfterH%, AfterL%)
 s0% = FSDPLAYNOTEDEL
 Soundcard FSDPLAYNOTEDEL, note%, duration%, Dlay%, AfterH%, AfterL%
END SUB

DEFINT A-Z
'*******************************************************************
'** This Routine Passes a Far Pointer to instrument parameters.   **
'** Since This can also represent a change of instruments at      **
'** a future time as specified in num/den, the array must remain  **
'** valid. Since you can't dim on the fly, or if someone knows of **
'** a technique to do it I would love to here it, I used a single **
'** table to hold all of the parameters. Believe me it's not as   **
'** bad as it sounds.                                             **
'*******************************************************************
'
SUB Setinstrument (ARRAY(), InsName$, num, den, ptr)

 BinSearch InsName$, Eno%
 Bsearch = FREEFILE
 OPEN "c:\Music\Standard.bnk" FOR BINARY AS Bsearch
 SEEK Bsearch, (Bh.DataOfF + (IndexInfo(Eno%).DIndex) * 30) + 1
 GET Bsearch, , Pdr
 GET Bsearch, , Parameter
 ARRAY(ptr + 1) = ASC(Parameter.KSL)
 ARRAY(ptr + 2) = ASC(Parameter.FM)
 ARRAY(ptr + 3) = ASC(Parameter.feedback)
 ARRAY(ptr + 4) = ASC(Parameter.Attack)
 ARRAY(ptr + 5) = ASC(Parameter.Sustain)
 ARRAY(ptr + 6) = ASC(Parameter.Slevel)
 ARRAY(ptr + 7) = ASC(Parameter.Decay)
 ARRAY(ptr + 8) = ASC(Parameter.Release)
 ARRAY(ptr + 9) = ASC(Parameter.VOutput)
 ARRAY(ptr + 10) = ASC(Parameter.AM)
 ARRAY(ptr + 11) = ASC(Parameter.Vib)
 ARRAY(ptr + 12) = ASC(Parameter.KSR)
 ARRAY(ptr + 13) = ASC(Parameter.Fmon)
 ARRAY(ptr + 14) = ASC(Parameter.CKSL)
 ARRAY(ptr + 15) = ASC(Parameter.CFM)
 ARRAY(ptr + 16) = ASC(Parameter.Unused)
 ARRAY(ptr + 17) = ASC(Parameter.CAttack)
 ARRAY(ptr + 18) = ASC(Parameter.CSustain)
 ARRAY(ptr + 19) = ASC(Parameter.CSSound)
 ARRAY(ptr + 20) = ASC(Parameter.CDecay)
 ARRAY(ptr + 21) = ASC(Parameter.CRelease)
 ARRAY(ptr + 22) = ASC(Parameter.CVolume)
 ARRAY(ptr + 23) = ASC(Parameter.CAM)
 ARRAY(ptr + 24) = ASC(Parameter.CVib)
 ARRAY(ptr + 25) = ASC(Parameter.CKSR)
 ARRAY(ptr + 26) = ASC(Parameter.CUnused)
 ARRAY(ptr + 27) = ASC(Parameter.Wave0)
 ARRAY(ptr + 28) = ASC(Parameter.Wave1)
 CLOSE Bsearch
 Soundcard FSDSETTIMBRE, VARPTR(ARRAY(ptr + 1)), VARSEG(ARRAY(ptr + 1)), num, den, NULL
END SUB

SUB SetInstrumentEvents (SongFile, voice%) STATIC

     GET SongFile, , Af             'This Af stuff is necessary because
                                   'I have to dump 15 unused bytes every
                                   'So often.

     GET SongFile, , NuminstruEvents
     FOR II = 1 TO NuminstruEvents.NumEvents
         GET SongFile, , InstrumentEvent
         Setinstrument INSTRUM(), InstrumentEvent.InstrumentName, InstrumentEvent.TimeInTicks, Mh.TicksPerBeat, Iptr%

         'Iptr% is a pointer into the INSTRUM() array. It is incremented
         'by 28 each time parameters are passed as there are 28 per inst
         'definition. This offset is used in calculating the far pointer
         'passed to the SOUND.COM driver.

         Iptr% = Iptr% + 28

' **** Save instrument names for later display *****
         NewIns$ = UCASE$(StripCString$(InstrumentEvent.InstrumentName))
         IF VoiceHeader.Vduration = NULL THEN NewIns$ = "UNUSED"
         Items$(IECount%) = STR$(voice%) + SPACE$(9 - (LEN(STR$(voice%)))) + NewIns$ + SPACE$(10 - LEN(NewIns$)) + STR$(InstrumentEvent.TimeInTicks)
         IECount% = IECount% + 1
     NEXT

END SUB

SUB SetMode (Mode%)
'Set Mode to PERCUSSIVE or MELODIC
 Soundcard FSDSETMODE, Mode, NULL, NULL, NULL, NULL
END SUB

SUB SetPitchEvents (SongFile)
 GET SongFile, , Af
 GET SongFile, , NumPitchEvents
     FOR Pitch = 1 TO NumPitchEvents.NumEvents
         GET SongFile, , PitchEvent
         Soundcard FSDSETPITCH, 0, (PitchEvent.VolMultiplier * -1), 0, PitchEvent.TimeEvent, Mh.TicksPerBeat
     NEXT
END SUB

SUB SetTempoEvents (SongFile)
 FOR TempoIndex = 1 TO Mh.TEvents            'Tempo changes which occur
     GET SongFile, , TempoEvent              'later in the piece.
     Soundcard FSDSETTEMPO, (Mh.Tempo * TempoEvent.Tmultiplier), TempoEvent.TimeEvent, Mh.TicksPerBeat, NULL, NULL
 NEXT TempoIndex
END SUB

DEFSNG A-Z
SUB SetVoice (voice%)
'SET active Voice  ( 0 - 11 )
 Soundcard FSDSETACTVOICE, voice%, NULL, NULL, NULL, NULL
END SUB

DEFINT A-Z
SUB SetVolumeEvents (SongFile)
'========== Set Volume Events ===========================================
 GET SongFile, , Af
 GET SongFile, , NumVolEvents
 FOR VI = 1 TO NumVolEvents.NumEvents
   GET SongFile, , VolumeEvent
   Soundcard 8, (255 * VolumeEvent.VolMultiplier), 255, VolumeEvent.TimeEvent, Mh.TicksPerBeat, 0
 NEXT
'==========================================================================
END SUB

SUB ShowIns (MaxRecord%)
 up$ = CHR$(0) + "H"
 Down$ = CHR$(0) + "P"
 PgDown$ = CHR$(0) + CHR$(81)
 PgUp$ = CHR$(0) + CHR$(73)
 Home$ = CHR$(0) + CHR$(71)
 End$ = CHR$(0) + CHR$(79)
 LCursor$ = CHR$(0) + CHR$(75)
 Rcursor$ = CHR$(0) + CHR$(77)
 BackSpace$ = CHR$(8)
 Esc$ = CHR$(27)

 Minrecord = 0
 StartRow% = 6
 Col% = 52
 IF MaxRecord% > 16 THEN MaxRecord% = 16
 FOR sl = Minrecord% TO MaxRecord%
 LOCATE StartRow + sl, Col%
 PRINT Items$(sl)
 NEXT
LTOP:
 Sel% = 0
 Spointer = 0
 LOCATE StartRow%, Col%
 COLOR 0, 11
 PRINT Items$(Sel%)
 SaveScreen
Hold:
 Char$ = INKEY$

        
         SELECT CASE Char$
                CASE ""
                     GOTO Hold
                CASE Esc$
                     RestoreScreen
                     GOTO LTOP
                CASE Down$
                     IF Sel% < MaxRecord THEN
                        LOCATE StartRow% + Sel%, Col%
                        COLOR 11, 0
                        PRINT Items$(Sel%)
                        LOCATE StartRow% + Sel% + 1, Col%
                        COLOR 0, 11
                        PRINT Items$(Sel% + 1)
                        Sel% = Sel% + 1
                        InstruStats (Sel% * 28)
                      END IF

                CASE up$
                     IF Sel% > Minrecord% THEN
                        LOCATE StartRow% + Sel%, Col%
                        COLOR 11, 0
                        PRINT Items$(Sel%)
                        Sel% = Sel% - 1
                        LOCATE StartRow% + Sel%, Col%
                        COLOR 0, 11
                        PRINT Items$(Sel%)
                        InstruStats (Sel% * 28)
                     END IF
                CASE CHR$(13)
                        InstruStats (Sel% * 28)
                     GOTO Hold
                CASE CHR$(32)
                     EXIT SUB
                CASE ELSE
          END SELECT
GOTO Hold
END SUB

SUB ShowStats
'Put Some Stats on the Screen...More to come later
 Pprint 6, 36, BankName$
 Pprint 7, 36, "Percussive"
 Pprint 8, 40, STR$(Mh.Tempo)
 Vprint 9, 40, Mh.TEvents
 Vprint 10, 40, NumPitchEvents.NumEvents
 Vprint 11, 40, NumVolEvents.NumEvents
 Vprint 12, 40, IECount%
 Vprint 13, 40, Mh.TicksPerBeat

END SUB

DEFSNG A-Z
SUB StartSong
'Start Playing
 Soundcard FSDSETSTATE, CARDON, NULL, NULL, NULL, NULL
END SUB

SUB StartTime
'Called By Initialize and explained there
 Soundcard FSDRELTIMESTART, 0, 1, NULL, NULL, NULL
END SUB

DEFINT A-Z
'This function is necessary because the File Names in the .Ins files
'are C or Zero Terminated strings making it impossible to do an
'RTRIM$ to tidy up
'
 FUNCTION StripCString$ (CString$)
 FOR l = 1 TO LEN(CString$)
     ch$ = MID$(CString$, l, 1)
     IF ch$ = CHR$(0) THEN EXIT FOR
     n$ = n$ + ch$          'Build New String until NULL encountered
 NEXT
 StripCString$ = n$
 END FUNCTION

DEFSNG A-Z
SUB Tempo (beats)
'Set Tempo to Beats per
 Soundcard FSDSETTEMPO, beats, 0, 1, 0, 0
END SUB

DEFINT A-Z
SUB Vprint (Row%, Col%, Var%)
                 LOCATE Row%, Col%
                 PRINT Var%
END SUB

